<?php

class View
{
	private
		$_parents = array(),
		$_names   = array(),
		$_blocks  = array();

	public function render($id, $data)
	{
		extract($data);
		require $this->_prepare($id);
		while (!empty($this->_parents)) {
			$this->_grab('content');
			extract($this->_blocks);
			require $this->_prepare($id = array_pop($this->_parents));
		}
	}

	protected function _prepare($id)
	{
		return './templates/' . $id . '.php';
	}

	private function _extend($id)
	{
		array_push($this->_parents, $id);
		ob_start();
	}

	private function _blockBegin($name)
	{
		array_push($this->_names, $name);
		ob_start();
	}

	private function _blockEnd()
	{
		$this->_grab(array_pop($this->_names));
	}

	private function _grab($name)
    {
		if (isset($this->_blocks[$name])) {
			ob_end_clean();
			return;
		}
		$tmp = ob_get_clean();
		if (strlen(trim($tmp)) > 0) {
			$this->_blocks[$name] = $tmp;
		}
	}

}
